#!/usr/bin/env ruby

lines = Array.new

open('cdl/CUBE_TOP.cdl').each do |line|
  lines << line.chomp
end


######## REMOVE WELL PORT FROM PAD_FILLER
del = false
lines.each_index do |i|
  case lines[i]
  when /^X/
    cell_name = lines[i].split(/\s+/)[1]
    if cell_name =~ /^ZCGCB2E4C0XXA1/
      del = true
      lines[i].gsub!('VNW=VNW', '')
      lines[i].gsub!('VPW=VPW', '')
    end
  when /^\+/
    if del
      lines[i].gsub!('VNW=VNW', '')
      lines[i].gsub!('VPW=VPW', '')
    end
  else
    del = false
  end
end


del_line_no = Array.new
lines.each_index do |i|
  if lines[i] =~ /^\+\s*$/
    del_line_no << i
  end
end
del_line_no.reverse!
del_line_no.each do |i|
  lines.delete_at(i)
end

open('cdl/CUBE_TOP_mod.cdl', 'w') do |dst|
  dst.print lines.join("\n") + "\n"
end
