set sdc_version 1.7

set_units -time ps -resistance Ohm -capacitance pF -voltage V -current mA
set_max_fanout 10 [current_design]
create_clock [get_ports IO_CLK]  -name clk  -period 5000  -waveform {0 2500}
set_clock_latency -max 100  [get_clocks clk]
set_clock_latency -min 0  [get_clocks clk]


set_input_delay -clock clk  1000  [get_ports IO_RST_N]

set_input_delay -clock clk  1000  [get_ports {IO_IDATA[3]}]
set_input_delay -clock clk  1000  [get_ports {IO_IDATA[2]}]
set_input_delay -clock clk  1000  [get_ports {IO_IDATA[1]}]
set_input_delay -clock clk  1000  [get_ports {IO_IDATA[0]}]

set_input_delay -clock clk  1000  [get_ports {IO_SEL[1]}]
set_input_delay -clock clk  1000  [get_ports {IO_SEL[0]}]

set_input_delay -clock clk  1000  [get_ports IO_WR]

set_output_delay -clock clk  1000  [get_ports {IO_ODATA[2]}]
set_output_delay -clock clk  1000  [get_ports {IO_ODATA[1]}]
set_output_delay -clock clk  1000  [get_ports {IO_ODATA[0]}]

set_output_delay -clock clk  1000  [get_ports {IO_PROBE[8]}]
set_output_delay -clock clk  1000  [get_ports {IO_PROBE[7]}]
set_output_delay -clock clk  1000  [get_ports {IO_PROBE[6]}]
set_output_delay -clock clk  1000  [get_ports {IO_PROBE[5]}]
set_output_delay -clock clk  1000  [get_ports {IO_PROBE[4]}]
set_output_delay -clock clk  1000  [get_ports {IO_PROBE[3]}]
set_output_delay -clock clk  1000  [get_ports {IO_PROBE[2]}]
set_output_delay -clock clk  1000  [get_ports {IO_PROBE[1]}]
set_output_delay -clock clk  1000  [get_ports {IO_PROBE[0]}]

set_output_delay -clock clk  1000  [get_ports IO_OOSC]
set_output_delay -clock clk  1000  [get_ports IO_OCOUNTER]
set_output_delay -clock clk  1000  [get_ports IO_OMUX]
set_input_delay -clock clk  1000  [get_ports IO_IDEMUX]
set_input_delay -clock clk  1000  [get_ports IO_IRESET]
