###################################################################
# $Id: verify_fm.tcl 122 2010-08-15 07:43:46Z matutani $
###################################################################

#
# Reference and implemented Verilog netlist files
#
set SYN_NET	"../syn/cube.vnet"
set PR_NET	"../pr/cube_out.v"

#
# Library directory
#
set LIB_DIR "/home/vdec/lib/fujitsu65/cs202_sc_io_lib/db"
set search_path  [concat "." $LIB_DIR $search_path]

#
# Libraries
#
read_db { \
cs202sz_uc_aob_t_p25_12v.db cs202sz_uc_core_t_p25_12v.db cs202sz_uc_dscan_t_p25_12v.db cs202sz_uc_eco_t_p25_12v.db cs202sz_uc_iso_t_p25_12v.db cs202sz_uc_nscan_t_p25_12v.db cs202sz_uc_scan_t_p25_12v.db}

#
# Reference (r) Verilog read
#
read_verilog -container r -libname WORK -01 $SYN_NET
set_top r:/WORK/cube

#
# Implemented (i) Verilog read
#
read_verilog -container i -libname WORK -01 $PR_NET
set_top i:/WORK/cube

#
# Compare!
#
match
verify

exit
###################################################################
