/* $Id: induct_dummy150.v 89 2010-08-10 11:10:02Z matutani $ */
module ptp (
	odata0,
	iack1,
	idata2,
	oack3,
	bsel0, 
	bsel1, 
	bsel2, 
	bsel3,
	clk, 
	ireset
);
output  [34:0] odata0;
input	[1:0]  iack1;
input	[34:0] idata2;
output	[1:0]  oack3;
input	[1:0]  bsel0;
input	[1:0]  bsel1;
input	[1:0]  bsel2;
input	[1:0]  bsel3;
input	       clk;
input          ireset;

reg 	[34:0] buf0;
reg 	[1:0]  ackbuf;
wire 	[1:0]  bsel;

assign odata0 = buf0;
assign oack3  = ackbuf;
assign bsel   = bsel0 & bsel1 & bsel2 & bsel3;
always @(posedge clk ) begin
	if(ireset)
		buf0 <= 0;
	else if (bsel == 2'b10)  begin
		buf0	<= idata2;	
		ackbuf	<= iack1;
	end
end
endmodule
