set lib [current_mw_lib]
remove_antenna_rules $lib

define_antenna_layer_ratio_scale $lib -layer "MET1"    -layer_scale 1     -accumulate_scale 1
define_antenna_layer_ratio_scale $lib -layer "MET2"    -layer_scale 1     -accumulate_scale 1
define_antenna_layer_ratio_scale $lib -layer "MET3"    -layer_scale 1     -accumulate_scale 1
define_antenna_layer_ratio_scale $lib -layer "MET4"    -layer_scale 1     -accumulate_scale 1
define_antenna_layer_ratio_scale $lib -layer "MET5"    -layer_scale 1     -accumulate_scale 1
define_antenna_layer_ratio_scale $lib -layer "MET6"    -layer_scale 1     -accumulate_scale 1
define_antenna_layer_ratio_scale $lib -layer "METS1"    -layer_scale 1     -accumulate_scale 1
define_antenna_layer_ratio_scale $lib -layer "METS2"    -layer_scale 1     -accumulate_scale 1
define_antenna_layer_ratio_scale $lib -layer "METS3"    -layer_scale 1     -accumulate_scale 1
define_antenna_layer_ratio_scale $lib -layer "METG1"    -layer_scale 1     -accumulate_scale 1
define_antenna_layer_ratio_scale $lib -layer "METG2"    -layer_scale 1     -accumulate_scale 1
define_antenna_layer_ratio_scale $lib -layer "METTOP"    -layer_scale 1     -accumulate_scale 1
define_antenna_layer_ratio_scale $lib -layer "CUTS1"    -layer_scale 30.0     -accumulate_scale 30.0
define_antenna_layer_ratio_scale $lib -layer "CUTS2"    -layer_scale 30.0     -accumulate_scale 30.0
define_antenna_layer_ratio_scale $lib -layer "CUTS3"    -layer_scale 30.0     -accumulate_scale 30.0
define_antenna_layer_ratio_scale $lib -layer "CUTG1"    -layer_scale 7.5     -accumulate_scale 7.5
define_antenna_layer_ratio_scale $lib -layer "CUTG2"    -layer_scale 7.5     -accumulate_scale 7.5
define_antenna_layer_ratio_scale $lib -layer "CUTTOP"    -layer_scale 12.0     -accumulate_scale 12.0

define_antenna_rule $lib -mode 2 -diode_mode 4 -metal_ratio 2000 -cut_ratio 2000
define_antenna_layer_rule $lib -mode 2 -layer "MET1"   -ratio 2000 -diode_ratio {0.01919 0 1 100000}
define_antenna_layer_rule $lib -mode 2 -layer "MET2"   -ratio 2000 -diode_ratio {0.01919 0 1 100000}
define_antenna_layer_rule $lib -mode 2 -layer "MET3"   -ratio 2000 -diode_ratio {0.01919 0 1 100000}
define_antenna_layer_rule $lib -mode 2 -layer "MET4"   -ratio 2000 -diode_ratio {0.01919 0 1 100000}
define_antenna_layer_rule $lib -mode 2 -layer "MET5"   -ratio 2000 -diode_ratio {0.01919 0 1 100000}
define_antenna_layer_rule $lib -mode 2 -layer "MET6"   -ratio 2000 -diode_ratio {0.01919 0 1 100000}
define_antenna_layer_rule $lib -mode 2 -layer "METS1"   -ratio 2000 -diode_ratio {0.01919 0 1 100000}
define_antenna_layer_rule $lib -mode 2 -layer "METS2"   -ratio 2000 -diode_ratio {0.01919 0 1 100000}
define_antenna_layer_rule $lib -mode 2 -layer "METS3"   -ratio 2000 -diode_ratio {0.01919 0 1 100000}
define_antenna_layer_rule $lib -mode 2 -layer "METG1"   -ratio 2000 -diode_ratio {0.01919 0 1 100000}
define_antenna_layer_rule $lib -mode 2 -layer "METG2"   -ratio 2000 -diode_ratio {0.01919 0 1 100000}
define_antenna_layer_rule $lib -mode 2 -layer "METTOP"   -ratio 2000 -diode_ratio {0.01919 0 1 100000}
define_antenna_layer_rule $lib -mode 2 -layer "CUT12"   -ratio 2000 -diode_ratio {0.01919 0 1 100000}
define_antenna_layer_rule $lib -mode 2 -layer "CUT23"   -ratio 2000 -diode_ratio {0.01919 0 1 100000}
define_antenna_layer_rule $lib -mode 2 -layer "CUT34"   -ratio 2000 -diode_ratio {0.01919 0 1 100000}
define_antenna_layer_rule $lib -mode 2 -layer "CUT45"   -ratio 2000 -diode_ratio {0.01919 0 1 100000}
define_antenna_layer_rule $lib -mode 2 -layer "CUT56"   -ratio 2000 -diode_ratio {0.01919 0 1 100000}
define_antenna_layer_rule $lib -mode 2 -layer "CUTS1"   -ratio 2000 -diode_ratio {0.01919 0 1 100000}
define_antenna_layer_rule $lib -mode 2 -layer "CUTS2"   -ratio 2000 -diode_ratio {0.01919 0 1 100000}
define_antenna_layer_rule $lib -mode 2 -layer "CUTS3"   -ratio 2000 -diode_ratio {0.01919 0 1 100000}
define_antenna_layer_rule $lib -mode 2 -layer "CUTG1"   -ratio 2000 -diode_ratio {0.01919 0 1 100000}
define_antenna_layer_rule $lib -mode 2 -layer "CUTG2"   -ratio 2000 -diode_ratio {0.01919 0 1 100000}
define_antenna_layer_rule $lib -mode 2 -layer "CUTTOP"   -ratio 2000 -diode_ratio {0.01919 0 1 100000}

